VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cAnimation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetTickCount Lib "kernel32" () As Long

Public Enum AnimationOrientation
    Vertical
    Horisontal
End Enum

Private m_AutoReplay        As Boolean
Private m_DestinationDC     As Long
Private m_AnimationDC       As Long
Private m_Left              As Long
Private m_Top               As Long
Private m_Frames            As Long
Private m_FrameWidth        As Long
Private m_FrameHeight       As Long
Private m_FramesPerSecond   As Long
Private m_Orientation       As AnimationOrientation

Private lCounter            As Long
Private bRunning            As Boolean
Private lFrame              As Long
Private bVertical           As Boolean
'

Public Property Get AutoReplay() As Boolean
    AutoReplay = m_AutoReplay
End Property
Public Property Let AutoReplay(b As Boolean)
    m_AutoReplay = b
End Property
'

Public Property Get DestinationDC() As Long
    DestinationDC = m_DestinationDC
End Property
Public Property Let DestinationDC(dc As Long)
    m_DestinationDC = dc
End Property
'

Public Property Get AnimationDC() As Long
    AnimationDC = m_AnimationDC
End Property
Public Property Let AnimationDC(dc As Long)
    m_AnimationDC = dc
End Property
'

Public Property Get Left() As Long
    Left = m_Left
End Property
Public Property Let Left(l As Long)
    m_Left = l
End Property
'

Public Property Get Top() As Long
    Top = m_Top
End Property
Public Property Let Top(l As Long)
    m_Top = l
End Property
'

Public Property Get Frames() As Long
    Frames = m_Frames
End Property
Public Property Let Frames(l As Long)
    m_Frames = l
End Property
'

Public Property Get FrameWidth() As Long
    FrameWidth = m_FrameWidth
End Property
Public Property Let FrameWidth(l As Long)
    m_FrameWidth = l
End Property
'

Public Property Get FrameHeight() As Long
    FrameHeight = m_FrameHeight
End Property
Public Property Let FrameHeight(l As Long)
    m_FrameHeight = l
End Property
'

Public Property Get FramesPerSecond() As Long
    FramesPerSecond = m_FramesPerSecond
End Property
Public Property Let FramesPerSecond(l As Long)
    m_FramesPerSecond = l
End Property
'

Public Property Get Orientation() As AnimationOrientation
    Orientation = m_Orientation
End Property
Public Property Let Orientation(o As AnimationOrientation)
    m_Orientation = o
End Property
'

Public Sub StartAnimation(Optional ByVal StartFrame As Long = 1)
    
    If StartFrame > m_Frames Then
        StartFrame = m_Frames
    End If
    
    lFrame = StartFrame
    
    bRunning = True
    Animate
    
End Sub
'

Public Sub StopAnimation()
    
    bRunning = False
    lFrame = 1
    
End Sub
'

Public Sub PauseAnimation()
    
    bRunning = False
    
End Sub
'

Public Sub ResumeAnimation()
    
    bRunning = True
    Animate
    
End Sub
'

'
' *************************************************************************************
'

Private Sub Animate()
    
    Dim x   As Long
    Dim y   As Long
    
    Do While bRunning
        
        If lCounter + 1000 / m_FramesPerSecond <= GetTickCount Then
            
            lCounter = GetTickCount
            
            x = IIf(m_Orientation = Horisontal, (lFrame - 1) * m_FrameWidth, 0)
            y = IIf(m_Orientation = Horisontal, 0, (lFrame - 1) * m_FrameHeight)
            
            BitBlt m_DestinationDC, m_Left, m_Top, m_FrameWidth, m_FrameHeight, _
                   m_AnimationDC, x, y, vbSrcCopy
            
            lFrame = lFrame + 1
            
            If lFrame > m_Frames Then
                If m_AutoReplay Then
                    lFrame = 1
                Else
                    bRunning = False
                End If
            End If
                    
        End If
        
        DoEvents
    
    Loop
    
End Sub
'

Private Sub Class_Initialize()
    
    m_FramesPerSecond = 5
    
End Sub
'

Private Sub Class_Terminate()
    
    bRunning = False
    
End Sub
